﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="MembershipManager.ascx.cs" Inherits="MembershipManager.UserControls.MembershipManager" %>
<%@ Register Assembly="Telerik.Web.UI" Namespace="Telerik.Web.UI" TagPrefix="telerik" %>

<div style="background-color: #e0e0e0">
    <telerik:RadTabStrip ID="RadTabStrip1" runat="server" skin="Vista" MultiPageID="RadMultiPage1" SelectedIndex="0">
        <Tabs>
            <telerik:RadTab Text="User Manager"></telerik:RadTab>
            <telerik:RadTab Text="Role Manager"></telerik:RadTab>
        </Tabs>
    </telerik:RadTabStrip>
</div>
<div style="border-top:3px solid #9999bb">

<telerik:RadMultiPage ID="RadMultiPage1" runat="server" SelectedIndex="0" Width="100%">
    <telerik:RadPageView ID="PageView1" runat="server">
    <asp:Panel ID="DetailsPanel" runat="server">    
        <telerik:RadGrid ID="UserGrid" runat="server" GridLines="None"
                      Skin="WebBlue" 
                      EnableAJAX="true" 
                      ShowFooter="true" 
                      ShowStatusBar="true" 
                      AllowSorting="true" 
                      AutoGenerateColumns="false" 
                      ShowGroupPanel="true" 
                      AllowFilteringByColumn="true"  
                      GroupingSettings-CaseSensitive="false" 
                      ClientSettings-EnablePostBackOnRowClick="false" 
                      GroupingEnabled="true"
                      >
            <MasterTableView Name="UserTable" 
                                AllowMultiColumnSorting="False" 
                                Width= "100%" 
                                AllowFilteringByColumn="true" 
                                DataKeyNames="Username"
                                PagerStyle-Mode="NextPrevAndNumeric"
                                AllowPaging="true"
                                AllowCustomSorting="false"
                                AllowNaturalSort="false"
                                PageSize="10">
            <DetailTables>
                <telerik:GridTableView Name="RoleGrid"
                                    AllowFilteringByColumn="false" 
                                    ShowHeader="true" 
                                    ShowFooter="false" 
                                    Frame="Border" 
                                    AllowSorting="true" 
                                    HierarchyLoadMode="ServerOnDemand" 
                                    CommandItemSettings-AddNewRecordText="Add To Role"
                                    EditMode="inPlace" 
                                    CommandItemDisplay="bottom" 
                                    DataKeyNames="RoleName"
                                    AllowAutomaticInserts="true" 
                                    AllowAutomaticDeletes="true" 
                                    AllowAutomaticUpdates="true" >
                    <Columns>
                        <telerik:GridTemplateColumn UniqueName="RowNumColumn" HeaderText="" AllowFiltering="false" ItemStyle-HorizontalAlign="center">
                            <ItemTemplate>
                                <asp:Label ID="numberLabel" runat="server" Width="25px" />
                            </ItemTemplate>
                            <HeaderStyle Width="30px" />
                        </telerik:GridTemplateColumn>      

                        <telerik:GridTemplateColumn UniqueName="RoleName" HeaderText="Role Name" SortExpression="RoleName" DataField="RoleName" GroupByExpression="RoleName Group By RoleName">
                            <HeaderStyle Width="250px" />
                            <ItemTemplate>
                                <asp:Label id="RoleNameLabel" runat="server">
                                <%#DataBinder.Eval(Container.DataItem, "RoleName")%>
                                </asp:Label>
                            </ItemTemplate>
                            <EditItemTemplate>
                                <telerik:RadComboBox ID="RoleComboBox" runat="server" 
                                                  Skin="ClassicBlue" 
                                                  DataTextField="RoleName" 
                                                  DataSourceID="SqlDataSource2" 
                                                  DataValueField="RoleName" 
                                                  AutoPostBack="false"
                                                  Width="250px">
                            </telerik:RadComboBox>
                            </EditItemTemplate>
                        </telerik:GridTemplateColumn>

                  <telerik:GridEditCommandColumn FilterImageUrl="" SortAscImageUrl="" SortDescImageUrl="" ButtonType="ImageButton" ItemStyle-CssClass="imgButton">
                    <ItemStyle HorizontalAlign="Center" Width="40px"/>
                    </telerik:GridEditCommandColumn>

                    <telerik:GridButtonColumn CommandName="Delete" Text="Remove Role" UniqueName="column" ButtonType="ImageButton" ConfirmText="Are you sure you want to remove the user from this role?" ItemStyle-CssClass="imgButton">
                        <HeaderStyle Width="20px" />
                    </telerik:GridButtonColumn>
                    </Columns>
                </telerik:GridTableView>
            </DetailTables>
                <Columns>
                        <telerik:GridTemplateColumn UniqueName="RowNumColumn" HeaderText="" AllowFiltering="false" ItemStyle-HorizontalAlign="Center">
                            <ItemTemplate>
                                <asp:Label ID="numberLabel" runat="server" Width="25px" />
                            </ItemTemplate>
                            <HeaderStyle Width="30px" />
                        </telerik:GridTemplateColumn>                
                        <telerik:GridBoundColumn SortExpression="Firstname" HeaderText="Firstname" AllowFiltering="true" HeaderButtonType="TextButton"
                            DataField= "Firstname" UniqueName="Firstname" ItemStyle-Width="75" Groupable="true"/>

                        <telerik:GridBoundColumn SortExpression="Lastname" HeaderText="Lastname" HeaderButtonType="TextButton"
                            DataField= "Lastname" UniqueName="Lastname" ItemStyle-Width="75" Groupable="true"/>

                        <telerik:GridBoundColumn SortExpression="Company" HeaderText="Company" HeaderButtonType="TextButton"
                            DataField= "Company" UniqueName="Company" ItemStyle-Width="100" Groupable="true"/>

                        <telerik:GridBoundColumn SortExpression="Username" HeaderText="Username" HeaderButtonType="TextButton"
                            DataField= "Username" UniqueName="Username" ItemStyle-Width="100" />

                        <telerik:GridBoundColumn SortExpression="Email" HeaderText="Email" HeaderButtonType="TextButton"
                            DataField= "Email" UniqueName="Email" ItemStyle-Width="175" />

                        <telerik:GridBoundColumn SortExpression="LastLoginDate" HeaderText="Last Login" HeaderButtonType="TextButton"
                            DataField= "LastLoginDate" UniqueName="LastLoginDate"  ItemStyle-Width="120" />

                    <telerik:GridButtonColumn CommandName="Delete" Text="Delete User" UniqueName="column" ButtonType="ImageButton" ConfirmText="Are you sure you want to delete this user?" ItemStyle-CssClass="imgButton">
                        <HeaderStyle Width="20px" />
                    </telerik:GridButtonColumn>
                            
                </Columns>
                <PagerStyle AlwaysVisible="True" />
            </MasterTableView>
                <ClientSettings AllowColumnsReorder="true" 
                                AllowDragToGroup="true" 
                                AllowKeyboardNavigation="true"
                                AllowColumnHide="True" 
                                AllowExpandCollapse="True" 
                                AllowGroupExpandCollapse="True" >
                    <Resizing AllowColumnResize="true" EnableRealTimeResize="true" />
                    <Selecting AllowRowSelect="true" />
                    <Scrolling AllowScroll="false" UseStaticHeaders="true"  />
                </ClientSettings>            
        </telerik:RadGrid>
    </asp:Panel>
  
    <asp:SqlDataSource ID="SqlDataSource2" runat="server" ConnectionString="<%$ ConnectionStrings:MembershipConnectionString %>"
        SelectCommand="SELECT [RoleName] FROM [vw_aspnet_Roles] ORDER BY [RoleName]"></asp:SqlDataSource>
    </telerik:RadPageView>





    <telerik:RadPageView ID="PageView2" runat="server" Width="100%">
        <asp:Panel ID="RolesPanel" runat="server">
        <telerik:RadGrid ID="RoleAdminGrid" runat="server"
                          EnableAJAX="true" 
                          GridLines="None" 
                          DataSourceID="SqlDataSource1"
                          Skin="WebBlue" 
                          ShowFooter="True" 
                          ShowStatusBar="True" 
                          AllowSorting="True" 
                          AutoGenerateColumns="False" 
                          AllowPaging="True"
                          AllowFilteringByColumn="True"  
                          GroupingSettings-CaseSensitive="false" 
                          ClientSettings-EnablePostBackOnRowClick="false">
            <ClientSettings>
                <Selecting AllowRowSelect="True" />
            </ClientSettings>
            <MasterTableView name="RolesTable" DataSourceID="SqlDataSource1"
                             Width= "100%" 
                             DataKeyNames="RoleName"
                             AllowAutomaticInserts="True" 
                             AllowAutomaticDeletes="True" 
                             AllowAutomaticUpdates="True"
                             EditMode="InPlace" 
                             CommandItemDisplay="Top" 
                             >
                <DetailTables>
                <telerik:GridTableView Name="UsersinRolesTable"
                                AllowMultiColumnSorting="false" 
                                AllowFilteringByColumn="true" 
                                DataKeyNames="Username"
                                PagerStyle-Mode="NextPrevAndNumeric"
                                AllowPaging="true"
                                AllowCustomSorting="false"
                                AllowNaturalSort="false"
                                PageSize="10" 
                                PagerStyle-AlwaysVisible="true" 
                                ShowHeader="true"
                                >
                    <Columns>
                        <telerik:GridBoundColumn SortExpression="Firstname" HeaderText="Firstname" AllowFiltering="true" HeaderButtonType="TextButton"
                            DataField= "Firstname" UniqueName="Firstname" ItemStyle-Width="75" Groupable="true"/>

                        <telerik:GridBoundColumn SortExpression="Lastname" HeaderText="Lastname" HeaderButtonType="TextButton"
                            DataField= "Lastname" UniqueName="Lastname" ItemStyle-Width="75" Groupable="true"/>

                        <telerik:GridBoundColumn SortExpression="Company" HeaderText="Company" HeaderButtonType="TextButton"
                            DataField= "Company" UniqueName="Company" ItemStyle-Width="100" Groupable="true"/>

                        <telerik:GridBoundColumn SortExpression="Username" HeaderText="Username" HeaderButtonType="TextButton"
                            DataField= "Username" UniqueName="Username" ItemStyle-Width="100" />

                        <telerik:GridBoundColumn SortExpression="Email" HeaderText="Email" HeaderButtonType="TextButton"
                            DataField= "Email" UniqueName="Email" ItemStyle-Width="175" />

                        <telerik:GridBoundColumn SortExpression="LastLoginDate" HeaderText="Last Login" HeaderButtonType="TextButton"
                            DataField= "LastLoginDate" UniqueName="LastLoginDate"  ItemStyle-Width="120" />

                    <telerik:GridButtonColumn CommandName="Delete" Text="Remove from Role" UniqueName="column" ButtonType="ImageButton" ConfirmText="Are you sure you want to remove the user? \r(Will not delete the user - only remove them from the role)" ItemStyle-CssClass="imgButton">
                        <HeaderStyle Width="20px" />
                    </telerik:GridButtonColumn>
                    </Columns>
                </telerik:GridTableView>
                </DetailTables>
                <Columns>
                    <telerik:GridBoundColumn SortExpression="RoleName" HeaderText="Roles" HeaderButtonType="TextButton"
                        DataField= "RoleName" UniqueName="RoleName">
                        <ItemStyle Width="100%" />
                    </telerik:GridBoundColumn>

                    <telerik:GridEditCommandColumn ButtonType="ImageButton" display="false">
                        <HeaderStyle Width="40px" />
                        <ItemStyle HorizontalAlign="Center" Width="40px" CssClass="imgButton"/>
                    </telerik:GridEditCommandColumn>

                    <telerik:GridButtonColumn CommandName="Delete" Text="Delete Role" UniqueName="column" ButtonType="ImageButton" ConfirmText="Are you sure you want to delete this role?">
                        <HeaderStyle Width="20px" />
                        <ItemStyle CssClass="imgButton" />
                    </telerik:GridButtonColumn>
                </Columns>
                <CommandItemSettings AddNewRecordText="Add New Role" />
                <ExpandCollapseColumn Visible="False">
                    <HeaderStyle Width="19px" />
                </ExpandCollapseColumn>
                <PagerStyle Mode="NextPrevAndNumeric" />
                <RowIndicatorColumn Visible="False">
                    <HeaderStyle Width="20px" />
                </RowIndicatorColumn>
            </MasterTableView>
            <GroupingSettings CaseSensitive="False" />
            <PagerStyle Mode="Advanced" />
        </telerik:RadGrid></asp:Panel>    
 
        
        <asp:SqlDataSource ID="SqlDataSource1" runat="server" ConnectionString="<%$ ConnectionStrings:MembershipConnectionString %>"
            SelectCommand="SELECT [RoleName] FROM [vw_aspnet_Roles] ORDER BY [RoleName]"></asp:SqlDataSource>

    </telerik:RadPageView>
</telerik:RadMultiPage>
</div>