﻿using System;
using System.Configuration;
using System.Web.Configuration;
using Telerik.Web.UI;
using System.Data.SqlClient;
using System.Data;
using System.IO;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Web.Security;

namespace MembershipManager.UserControls
{
    public partial class MembershipManager : System.Web.UI.UserControl
    {
        protected RadGrid grid;
        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);
        }
        private DataTable GetSQLData(string query)
        {
            ConnectionStringSettings settings;
            settings = ConfigurationManager.ConnectionStrings["MembershipConnectionString"];
            SqlConnection dbCon = new SqlConnection(settings.ConnectionString);
            dbCon.Open();

            SqlDataAdapter adapter = new SqlDataAdapter(query, dbCon);
            DataTable dt = new DataTable();
            adapter.Fill(dt);
            dbCon.Close();

            return dt;
        }
        //GetSQLData


        protected void Page_Load(object sender, System.EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                UserDataRow.LastLoginDateComparer LastLoginDateComparer = new UserDataRow.LastLoginDateComparer(false);
                GridSortExpression expression = new GridSortExpression();
                expression.FieldName = "LastLoginDate";
                expression.SortOrder = GridSortOrder.Descending;
                UserGrid.MasterTableView.SortExpressions.AddSortExpression(expression);
                UserGrid.Rebind();
            }
        }


        protected void UserGrid_DeleteCommand(object source, GridCommandEventArgs e)
        {
            if (e.CommandName == RadGrid.DeleteCommandName && e.Item.OwnerTableView.Name == "RoleGrid")
            {
                string Username = e.Item.OwnerTableView.ParentItem["Username"].Text;

                GridDataItem RoleItem = (GridDataItem)e.Item;
                string RoleName = RoleItem.OwnerTableView.DataKeyValues[e.Item.ItemIndex]["RoleName"].ToString();

                Roles.RemoveUserFromRole(Username, RoleName);
            }
            if (e.CommandName == RadGrid.DeleteCommandName && e.Item.OwnerTableView.Name == "UserTable")
            {
                GridDataItem UserItem = (GridDataItem)e.Item;
                string Username = UserItem.OwnerTableView.DataKeyValues[e.Item.ItemIndex]["Username"].ToString();

                Membership.DeleteUser(Username);
            }
        }

                
        protected void UserGrid_InsertCommand(object source, GridCommandEventArgs e)
        {
            if (e.CommandName == RadGrid.PerformInsertCommandName)
            {
                e.Canceled = true;
                string Username = e.Item.OwnerTableView.ParentItem["Username"].Text;
                RadComboBox box = (RadComboBox)e.Item.FindControl("RoleComboBox");
                Roles.AddUserToRole(Username, box.SelectedItem.Text);
                e.Item.Edit = false;
                e.Item.OwnerTableView.Rebind();
            }
        }


        protected void UserGrid_ItemDataBound(object sender, GridItemEventArgs e)
        {
            if ((e.Item is GridDataItem))
            {
                Label lbl = (Label)e.Item.FindControl("numberLabel");
                string item = Convert.ToString(e.Item.ItemIndex);
                lbl.Text = Convert.ToString(item + 1);
            }
            if (e.Item.IsInEditMode == true)
            {
                GridEditableItem EditItem = (GridEditableItem)e.Item;

                string Username = e.Item.OwnerTableView.ParentItem["Username"].Text;
                RadComboBox box = (RadComboBox)EditItem.FindControl("RoleComboBox");

                string sql = "SELECT aspnet_Roles.RoleName FROM aspnet_UsersInRoles INNER JOIN aspnet_Roles ON aspnet_UsersInRoles.RoleId = aspnet_Roles.RoleId INNER JOIN aspnet_Users ON aspnet_UsersInRoles.UserId = aspnet_Users.UserId WHERE aspnet_Users.UserName = '{0}' ORDER BY RoleName";
                sql = String.Format(sql, Username);
                DataTable dt = GetSQLData(sql);
                foreach (DataRow role in dt.Rows)
                {
                    //box.FindItemByText(role("RoleName")).Remove();
                }
            }
        }

        protected void UserGrid_NeedDataSource(object source, GridNeedDataSourceEventArgs e)
        {
            if (!e.IsFromDetailTable)
            {
                ArrayList UserTable = GetUserTable();
                this.grid = UserGrid;
                this.grid.DataSource = UserTable;
            }
        }

        private object GetUserTable()
        {
            MembershipUserCollection Users = Membership.GetAllUsers();
            ArrayList UserTable = new ArrayList();

            foreach (MembershipUser item in Users)
            {
                UserDataRow UserRow = new UserDataRow();
                //UserRow.Firstname = Profile.GetProfile(item.UserName).Firstname;
                //UserRow.Lastname = Profile.GetProfile(item.UserName).Lastname;
                //UserRow.Company = Profile.GetProfile(item.UserName).Company;
                UserRow.Username = item.UserName;
                UserRow.Email = item.Email;
                UserRow.LastLoginDate = item.LastLoginDate;
                UserTable.Add(UserRow);
            }

            return UserTable;
        }

        private object GetUsersByRole(string RoleName)
        {
            Array Users = Roles.GetUsersInRole(RoleName);
            ArrayList UserTable = new ArrayList();

            foreach (string item in Users)
            {
                UserDataRow UserRow = new UserDataRow();
                //UserRow.Firstname = Profile.GetProfile(item).Firstname;
                //UserRow.Lastname = Profile.GetProfile(item).Lastname;
                //UserRow.Company = Profile.GetProfile(item).Company;
                UserRow.Username = item;
                UserRow.Email = Membership.GetUser(item).Email;
                UserRow.LastLoginDate = Membership.GetUser(item).LastLoginDate;
                UserTable.Add(UserRow);
            }

            return UserTable;
        }

        protected void UserGrid_SortCommand(object source, GridSortCommandEventArgs e)
        {
            if (e.CommandName == RadGrid.SortCommandName)
            {
                ArrayList UserTable = GetUserTable();
                if (e.CommandArgument == "Firstname")
                {
                    UserDataRow.FirstnameComparer FirstnameComparer = new UserDataRow.FirstnameComparer(false);
                    switch (e.NewSortOrder)
                    {
                        
                        case GridSortOrder.None:
                            e.Item.OwnerTableView.DataSource = UserTable;
                            e.Item.OwnerTableView.Rebind();
                            break; // TODO: might not be correct. Was : Exit Select

                            break;
                        case GridSortOrder.Ascending:
                            //UserDataRow.FirstnameComparer FirstnameComparer = new UserDataRow.FirstnameComparer(false);
                            UserTable.Sort(FirstnameComparer);
                            e.Item.OwnerTableView.DataSource = UserTable;
                            e.Item.OwnerTableView.Rebind();
                            break; // TODO: might not be correct. Was : Exit Select

                            break;
                        case GridSortOrder.Descending:
                            //UserDataRow.FirstnameComparer FirstnameComparer = new UserDataRow.FirstnameComparer(true);
                            UserTable.Sort(FirstnameComparer);
                            e.Item.OwnerTableView.DataSource = UserTable;
                            e.Item.OwnerTableView.Rebind();
                            break; // TODO: might not be correct. Was : Exit Select

                            break;
                    }
                }
                else if (e.CommandArgument == "Lastname")
                {
                    UserDataRow.LastnameComparer LastnameComparer = new UserDataRow.LastnameComparer(true);
                    switch (e.NewSortOrder)
                    {
                        case GridSortOrder.None:
                            e.Item.OwnerTableView.DataSource = UserTable;
                            e.Item.OwnerTableView.Rebind();
                            break; // TODO: might not be correct. Was : Exit Select

                            break;
                        case GridSortOrder.Ascending:
                            //UserDataRow.LastnameComparer LastnameComparer = new UserDataRow.LastnameComparer(false);
                            UserTable.Sort(LastnameComparer);
                            e.Item.OwnerTableView.DataSource = UserTable;
                            e.Item.OwnerTableView.Rebind();
                            break; // TODO: might not be correct. Was : Exit Select

                            break;
                        case GridSortOrder.Descending:
                            //UserDataRow.LastnameComparer LastnameComparer = new UserDataRow.LastnameComparer(true);
                            UserTable.Sort(LastnameComparer);
                            e.Item.OwnerTableView.DataSource = UserTable;
                            e.Item.OwnerTableView.Rebind();
                            break; // TODO: might not be correct. Was : Exit Select

                            break;
                    }
                }
                else if (e.CommandArgument == "Company")
                {
                    UserDataRow.CompanyComparer CompanyComparer = new UserDataRow.CompanyComparer(true);
                    switch (e.NewSortOrder)
                    {
                        case GridSortOrder.None:
                            e.Item.OwnerTableView.DataSource = UserTable;
                            e.Item.OwnerTableView.Rebind();
                            break; // TODO: might not be correct. Was : Exit Select

                            break;
                        case GridSortOrder.Ascending:
                            //UserDataRow.CompanyComparer CompanyComparer = new UserDataRow.CompanyComparer(false);
                            UserTable.Sort(CompanyComparer);
                            e.Item.OwnerTableView.DataSource = UserTable;
                            e.Item.OwnerTableView.Rebind();
                            break; // TODO: might not be correct. Was : Exit Select

                            break;
                        case GridSortOrder.Descending:
                            //UserDataRow.CompanyComparer CompanyComparer = new UserDataRow.CompanyComparer(true);
                            UserTable.Sort(CompanyComparer);
                            e.Item.OwnerTableView.DataSource = UserTable;
                            e.Item.OwnerTableView.Rebind();
                            break; // TODO: might not be correct. Was : Exit Select

                            break;
                    }
                }
                else if (e.CommandArgument == "Username")
                {
                    UserDataRow.UsernameComparer UsernameComparer = new UserDataRow.UsernameComparer(true);
                    switch (e.NewSortOrder)
                    {
                        case GridSortOrder.None:
                            e.Item.OwnerTableView.DataSource = UserTable;
                            e.Item.OwnerTableView.Rebind();
                            break; // TODO: might not be correct. Was : Exit Select

                            break;
                        case GridSortOrder.Ascending:
                            //UserDataRow.UsernameComparer UsernameComparer = new UserDataRow.UsernameComparer(false);
                            UserTable.Sort(UsernameComparer);
                            e.Item.OwnerTableView.DataSource = UserTable;
                            e.Item.OwnerTableView.Rebind();
                            break; // TODO: might not be correct. Was : Exit Select

                            break;
                        case GridSortOrder.Descending:
                            //UserDataRow.UsernameComparer UsernameComparer = new UserDataRow.UsernameComparer(true);
                            UserTable.Sort(UsernameComparer);
                            e.Item.OwnerTableView.DataSource = UserTable;
                            e.Item.OwnerTableView.Rebind();
                            break; // TODO: might not be correct. Was : Exit Select

                            break;
                    }
                }
                else if (e.CommandArgument == "Email")
                {
                    UserDataRow.EmailComparer EmailComparer = new UserDataRow.EmailComparer(true);
                    switch (e.NewSortOrder)
                    {
                        case GridSortOrder.None:
                            e.Item.OwnerTableView.DataSource = UserTable;
                            e.Item.OwnerTableView.Rebind();
                            break; // TODO: might not be correct. Was : Exit Select

                            break;
                        case GridSortOrder.Ascending:
                            //UserDataRow.EmailComparer EmailComparer = new UserDataRow.EmailComparer(false);
                            UserTable.Sort(EmailComparer);
                            e.Item.OwnerTableView.DataSource = UserTable;
                            e.Item.OwnerTableView.Rebind();
                            break; // TODO: might not be correct. Was : Exit Select

                            break;
                        case GridSortOrder.Descending:
                            //UserDataRow.EmailComparer EmailComparer = new UserDataRow.EmailComparer(true);
                            UserTable.Sort(EmailComparer);
                            e.Item.OwnerTableView.DataSource = UserTable;
                            e.Item.OwnerTableView.Rebind();
                            break; // TODO: might not be correct. Was : Exit Select

                            break;
                    }
                }
                else if (e.CommandArgument == "LastLoginDate")
                {
                    UserDataRow.LastLoginDateComparer LastLoginDateComparer = new UserDataRow.LastLoginDateComparer(true);
                    switch (e.NewSortOrder)
                    {
                        case GridSortOrder.None:
                            e.Item.OwnerTableView.DataSource = UserTable;
                            e.Item.OwnerTableView.Rebind();
                            break; // TODO: might not be correct. Was : Exit Select

                            break;
                        case GridSortOrder.Ascending:
                            //UserDataRow.LastLoginDateComparer LastLoginDateComparer = new UserDataRow.LastLoginDateComparer(false);
                            UserTable.Sort(LastLoginDateComparer);
                            e.Item.OwnerTableView.DataSource = UserTable;
                            e.Item.OwnerTableView.Rebind();
                            break; // TODO: might not be correct. Was : Exit Select

                            break;
                        case GridSortOrder.Descending:
                            //UserDataRow.LastLoginDateComparer LastLoginDateComparer = new UserDataRow.LastLoginDateComparer(true);
                            UserTable.Sort(LastLoginDateComparer);
                            e.Item.OwnerTableView.DataSource = UserTable;
                            e.Item.OwnerTableView.Rebind();
                            break; // TODO: might not be correct. Was : Exit Select

                            break;
                    }
                }

            }
        }


        protected void UserGrid_UpdateCommand(object source, GridCommandEventArgs e)
        {
            if (e.CommandName == RadGrid.UpdateCommandName)
            {
                e.Canceled = true;
                string Username = e.Item.OwnerTableView.ParentItem["Username"].Text;
                RadComboBox box = (RadComboBox)e.Item.FindControl("RoleComboBox");
                try
                {
                    GridDataItem RoleItem = (GridDataItem)e.Item;
                    string RoleName = RoleItem.OwnerTableView.DataKeyValues[e.Item.ItemIndex]["RoleName"].ToString();
                    Roles.RemoveUserFromRole(Username, RoleName);
                }
                catch (Exception ex)
                {
                }
                Roles.AddUserToRole(Username, box.SelectedItem.Text);
                e.Item.Edit = false;

                e.Canceled = true;
                e.Item.OwnerTableView.DataBind();
            }
        }

        protected void RoleAdminGrid_DeleteCommand(object source, GridCommandEventArgs e)
        {
            if (e.CommandName == RadGrid.DeleteCommandName && e.Item.OwnerTableView.Name == "RolesTable")
            {
                GridDataItem RoleItem = (GridDataItem)e.Item;
                string RoleName = RoleItem.OwnerTableView.DataKeyValues[e.Item.ItemIndex]["RoleName"].ToString();
                Roles.DeleteRole(RoleName);
            }

            if (e.CommandName == RadGrid.DeleteCommandName && e.Item.OwnerTableView.Name == "UsersinRolesTable")
            {
                GridDataItem UserItem = (GridDataItem)e.Item;
                string Username = UserItem.OwnerTableView.DataKeyValues[e.Item.ItemIndex]["Username"].ToString();
                string RoleName = e.Item.OwnerTableView.ParentItem["RoleName"].Text;
                Roles.RemoveUserFromRole(Username, RoleName);
            }
        }

        protected void RoleAdminGrid_DetailTableDataBind(object source, GridDetailTableDataBindEventArgs e)
        {
            GridDataItem dataItem = (GridDataItem)e.DetailTableView.ParentItem;
            string RoleName = dataItem.GetDataKeyValue("RoleName").ToString();
            ArrayList UserTable = (ArrayList)GetUsersByRole(RoleName);
            if (!e.DetailTableView.ItemsCreated)
            {
                GridSortExpression expression = new GridSortExpression();
                expression.FieldName = "LastLoginDate";
                expression.SortOrder = GridSortOrder.Descending;
                e.DetailTableView.SortExpressions.AddSortExpression(expression);
            }
            e.DetailTableView.DataSource = UserTable;
        }

        protected void RoleAdminGrid_InsertCommand(object source, GridCommandEventArgs e)
        {
            if (e.CommandName == RadGrid.PerformInsertCommandName)
            {
                e.Canceled = true;
                e.Item.Edit = false;
                GridDataItem RoleItem = (GridDataItem)e.Item;

                GridEditableItem editedItem = (GridEditableItem)e.Item;
                string Rolename = null;

                Hashtable newValues = new Hashtable();
                e.Item.OwnerTableView.ExtractValuesFromItem(newValues, editedItem);
                Rolename = newValues.Item("RoleName").ToString;

                Roles.CreateRole(Rolename);
                e.Canceled = true;
                e.Item.OwnerTableView.Rebind();
            }
        }

        protected void RoleAdminGrid_ItemCommand(object source, GridCommandEventArgs e)
        {
            if (e.CommandName == RadGrid.EditCommandName)
            {
                e.Canceled = true;
            }
            if (e.CommandName == RadGrid.InitInsertCommandName)
            {
                GridEditCommandColumn editcolumn = (GridEditCommandColumn)e.Item.OwnerTableView.GetColumn("EditCommandColumn");
                editcolumn.Display = true;
            }
            else if (e.CommandName == RadGrid.CancelCommandName)
            {
                GridEditCommandColumn editcolumn = (GridEditCommandColumn)e.Item.OwnerTableView.GetColumn("EditCommandColumn");
                editcolumn.Display = false;
            }
        }

    }

    public class UserDataRow : IComparable
    {

        protected string _Firstname = string.Empty;
        protected string _Lastname = string.Empty;
        protected string _Company = string.Empty;
        protected string _Username = string.Empty;
        protected string _Email = string.Empty;

        protected DateTime _LastLoginDate;


        public string Firstname
        {
            get { return _Firstname; }
            set { _Firstname = value; }
        }

        public string Lastname
        {
            get { return _Lastname; }
            set { _Lastname = value; }
        }

        public string Company
        {
            get { return _Company; }
            set { _Company = value; }
        }

        public string Username
        {
            get { return _Username; }
            set { _Username = value; }
        }

        public string Email
        {
            get { return _Email; }
            set { _Email = value; }
        }
        public DateTime LastLoginDate
        {
            get { return _LastLoginDate; }
            set { _LastLoginDate = value; }
        }

        public int CompareTo(object obj)
        {
            if (obj is UserDataRow)
            {
                UserDataRow UserRow = (UserDataRow)obj;

                return _LastLoginDate.CompareTo(UserRow._LastLoginDate);
            }

            throw new ArgumentException("object is not a UserDataRow");
        }

        public class FirstnameComparer : IComparer
        {

            private bool m_Reverse;
            public FirstnameComparer(bool reverse)
            {
                m_Reverse = reverse;
            }
            public int Compare(object x, object y)
            {
                UserDataRow userX = (UserDataRow)x;
                UserDataRow userY = (UserDataRow)y;

                if (m_Reverse)
                {
                    return string.Compare(userY.Firstname, userX.Firstname);
                }
                else
                {
                    return string.Compare(userX.Firstname, userY.Firstname);
                }

            }
        }

        public class LastnameComparer : IComparer
        {

            private bool m_Reverse;
            public LastnameComparer(bool reverse)
            {
                m_Reverse = reverse;
            }

            public int Compare(object x, object y)
            {
                UserDataRow userX = (UserDataRow)x;
                UserDataRow userY = (UserDataRow)y;

                if (m_Reverse)
                {
                    return string.Compare(userY.Lastname, userX.Lastname);
                }
                else
                {
                    return string.Compare(userX.Lastname, userY.Lastname);
                }
            }
        }

        public class CompanyComparer : IComparer
        {

            private bool m_Reverse;
            public CompanyComparer(bool reverse)
            {
                m_Reverse = reverse;
            }

            public int Compare(object x, object y)
            {
                UserDataRow userX = (UserDataRow)x;
                UserDataRow userY = (UserDataRow)y;

                if (m_Reverse)
                {
                    return string.Compare(userY.Company, userX.Company);
                }
                else
                {
                    return string.Compare(userX.Company, userY.Company);
                }
            }
        }

        public class UsernameComparer : IComparer
        {

            private bool m_Reverse;
            public UsernameComparer(bool reverse)
            {
                m_Reverse = reverse;
            }

            public int Compare(object x, object y)
            {
                UserDataRow userX = (UserDataRow)x;
                UserDataRow userY = (UserDataRow)y;

                if (m_Reverse)
                {
                    return string.Compare(userY.Username, userX.Username);
                }
                else
                {
                    return string.Compare(userX.Username, userY.Username);
                }
            }
        }

        public class EmailComparer : IComparer
        {

            private bool m_Reverse;
            public EmailComparer(bool reverse)
            {
                m_Reverse = reverse;
            }
            public int Compare(object x, object y)
            {
                UserDataRow userX = (UserDataRow)x;
                UserDataRow userY = (UserDataRow)y;

                if (m_Reverse)
                {
                    return string.Compare(userY.Email, userX.Email);
                }
                else
                {
                    return string.Compare(userX.Email, userY.Email);
                }
            }
        }

        public class LastLoginDateComparer : IComparer
        {

            private bool m_Reverse;
            public LastLoginDateComparer(bool reverse)
            {
                m_Reverse = reverse;
            }

            public int Compare(object x, object y)
            {
                UserDataRow userX = (UserDataRow)x;
                UserDataRow userY = (UserDataRow)y;

                if (m_Reverse)
                {
                    return DateTime.Compare(userY.LastLoginDate, userX.LastLoginDate);
                }
                else
                {
                    return DateTime.Compare(userX.LastLoginDate, userY.LastLoginDate);
                }
            }
        }
    }
}